deegree-services/deegree-webservices/src/main/java/org/deegree/console/AbstractCreateResourceBean.java
/*----------------------------------------------------------------------------
 This file is part of deegree
 Copyright (C) 2001-2013 by:
 - Department of Geography, University of Bonn -
 and
 - lat/lon GmbH -
 and
 - Occam Labs UG (haftungsbeschränkt) -
 and others

 This library is free software; you can redistribute it and/or modify it under
 the terms of the GNU Lesser General Public License as published by the Free
 Software Foundation; either version 2.1 of the License, or (at your option)
 any later version.
 This library is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 details.
 You should have received a copy of the GNU Lesser General Public License
 along with this library; if not, write to the Free Software Foundation, Inc.,
 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

 Contact information:

 e-mail: info@deegree.org
 website: http://www.deegree.org/
----------------------------------------------------------------------------*/
package org.deegree.console;

import static org.deegree.console.JsfUtils.getWorkspace;

import java.io.File;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.event.AjaxBehaviorEvent;

import org.deegree.console.metadata.ConfigExample;
import org.deegree.console.metadata.ResourceManagerMetadata;
import org.deegree.console.metadata.ResourceProviderMetadata;
import org.deegree.workspace.ResourceManager;
import org.deegree.workspace.ResourceProvider;
import org.deegree.workspace.standard.AbstractResourceProvider;
import org.deegree.workspace.standard.DefaultWorkspace;

/**
 * JSF backing bean for views of type "Create new XYZ resource".
 *
 * @author <a href="mailto:schneider@occamlabs.de">Markus Schneider</a>
 * @since 3.4
 */
@ManagedBean
@ViewScoped
public abstract class AbstractCreateResourceBean {

	private String id;

	private String type;

	private String configTemplate;

	private List<String> configTemplates;

	private transient ResourceManagerMetadata metadata;

	private File resourceDir;

	protected AbstractCreateResourceBean() {
		// required by JSF
	}

	protected AbstractCreateResourceBean(Class<? extends ResourceManager<?>> resourceMgrClass) {
		ResourceManager<?> mgr = getWorkspace().getResourceManager(resourceMgrClass);
		metadata = ResourceManagerMetadata.getMetadata(mgr, getWorkspace());
		File wsDir = ((DefaultWorkspace) getWorkspace()).getLocation();
		resourceDir = new File(wsDir, mgr.getMetadata().getWorkspacePath());
		if (!getTypes().isEmpty()) {
			type = getTypes().get(0);
			changeType(null);
		}
	}

	public String getId() {
		return id;
	}

	public void setId(final String id) {
		this.id = id;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public void changeType(AjaxBehaviorEvent event) {
		ResourceProvider<?> provider = metadata.getProvider(type);
		ResourceProviderMetadata md = ResourceProviderMetadata.getMetadata(provider);
		configTemplates = new ArrayList<String>(md.getExamples().keySet());
		if (configTemplates.isEmpty()) {
			configTemplate = null;
		}
		else {
			configTemplate = configTemplates.get(0);
		}
	}

	public List<String> getTypes() {
		return metadata.getProviderNames();
	}

	public String getConfigTemplate() {
		return configTemplate;
	}

	public void setConfigTemplate(String configTemplate) {
		this.configTemplate = configTemplate;
	}

	public List<String> getConfigTemplates() {
		return configTemplates;
	}

	public String create() {
		ResourceProvider<?> provider = metadata.getProvider(type);
		if (provider == null) {
			provider = metadata.getProviders().get(0);
		}
		ResourceProviderMetadata md = ResourceProviderMetadata.getMetadata(provider);
		final Map<String, ConfigExample> examples = md.getExamples();
		if (examples == null || !examples.containsKey(configTemplate)) {
			JsfUtils.indicateException("Creating resource", "Internal error: Example template missing!?");
			return getOutcome();
		}
		URL templateURL = md.getExamples().get(configTemplate).getContentLocation();
		try {
			URL schemaURL = null;
			if (provider != null && provider instanceof AbstractResourceProvider<?>) {
				schemaURL = ((AbstractResourceProvider<?>) provider).getSchema();
			}
			File resourceFile = new File(resourceDir, id + ".xml");
			if (resourceFile.exists()) {
				JsfUtils.indicateException("Creating resource", "Resource with this identifier already exists!");
				return getOutcome();
			}
			StringBuilder sb = new StringBuilder("/console/generic/xmleditor?faces-redirect=true");
			sb.append("&id=").append(id);
			sb.append("&schemaUrl=");
			if (schemaURL != null) {
				sb.append(schemaURL.toString());
			}
			sb.append("&resourceProviderClass=")
				.append(metadata.getManager().getMetadata().getProviderClass().getCanonicalName());
			sb.append("&nextView=").append(getOutcome());
			sb.append("&emptyTemplate=").append(templateURL);

			return sb.toString();
		}
		catch (Exception t) {
			JsfUtils.indicateException("Creating resource", t);
		}
		return getOutcome();
	}

	protected abstract String getOutcome();

}

deegree-services/deegree-webservices/src/main/java/org/deegree/console/connection/remoteows/CreateRemoteOwsBean.java
/*----------------------------------------------------------------------------
 This file is part of deegree
 Copyright (C) 2001-2013 by:
 - Department of Geography, University of Bonn -
 and
 - lat/lon GmbH -
 and
 - Occam Labs UG (haftungsbeschränkt) -
 and others

 This library is free software; you can redistribute it and/or modify it under
 the terms of the GNU Lesser General Public License as published by the Free
 Software Foundation; either version 2.1 of the License, or (at your option)
 any later version.
 This library is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 details.
 You should have received a copy of the GNU Lesser General Public License
 along with this library; if not, write to the Free Software Foundation, Inc.,
 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

 Contact information:

 e-mail: info@deegree.org
 website: http://www.deegree.org/
----------------------------------------------------------------------------*/
package org.deegree.console.connection.remoteows;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.bean.ViewScoped;

import org.deegree.console.AbstractCreateResourceBean;
import org.deegree.remoteows.RemoteOWSManager;

/**
 * JSF backing bean for "Create new remote OWS connection" view.
 *
 * @author <a href="mailto:schneider@occamlabs.de">Markus Schneider</a>
 * @since 3.4
 */
@ManagedBean
@ViewScoped
public class CreateRemoteOwsBean extends AbstractCreateResourceBean {

	public CreateRemoteOwsBean() {
		super(RemoteOWSManager.class);
	}

	@Override
	protected String getOutcome() {
		return "/console/connection/ows/index";
	}

}

deegree-services/deegree-webservices/src/main/java/org/deegree/console/connection/remoteows/RemoteOwsManagerBean.java
/*----------------------------------------------------------------------------
 This file is part of deegree, http://deegree.org/
 Copyright (C) 2001-2013 by:
 - Department of Geography, University of Bonn -
 and
 - lat/lon GmbH -

 This library is free software; you can redistribute it and/or modify it under
 the terms of the GNU Lesser General Public License as published by the Free
 Software Foundation; either version 2.1 of the License, or (at your option)
 any later version.
 This library is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 details.
 You should have received a copy of the GNU Lesser General Public License
 along with this library; if not, write to the Free Software Foundation, Inc.,
 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

 Contact information:

 lat/lon GmbH
 Aennchenstr. 19, 53177 Bonn
 Germany
 http://lat-lon.de/

 Department of Geography, University of Bonn
 Prof. Dr. Klaus Greve
 Postfach 1147, 53001 Bonn
 Germany
 http://www.geographie.uni-bonn.de/deegree/

 e-mail: info@deegree.org
 ----------------------------------------------------------------------------*/
package org.deegree.console.connection.remoteows;

import java.io.Serializable;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import org.deegree.console.AbstractResourceManagerBean;
import org.deegree.remoteows.RemoteOWSManager;

@ManagedBean
@ViewScoped
public class RemoteOwsManagerBean extends AbstractResourceManagerBean<RemoteOWSManager> implements Serializable {

	private static final long serialVersionUID = 1272052355293535515L;

	public RemoteOwsManagerBean() {
		super(RemoteOWSManager.class);
	}

	@Override
	public String getStartView() {
		return "/console/connection/ows/index";
	}

}

deegree-services/deegree-webservices/src/main/java/org/deegree/console/connection/sql/CreateSqlConnectionBean.java
/*----------------------------------------------------------------------------
 This file is part of deegree
 Copyright (C) 2001-2013 by:
 - Department of Geography, University of Bonn -
 and
 - lat/lon GmbH -
 and
 - Occam Labs UG (haftungsbeschränkt) -
 and others

 This library is free software; you can redistribute it and/or modify it under
 the terms of the GNU Lesser General Public License as published by the Free
 Software Foundation; either version 2.1 of the License, or (at your option)
 any later version.
 This library is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 details.
 You should have received a copy of the GNU Lesser General Public License
 along with this library; if not, write to the Free Software Foundation, Inc.,
 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

 Contact information:

 e-mail: info@deegree.org
 website: http://www.deegree.org/
----------------------------------------------------------------------------*/
package org.deegree.console.connection.sql;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import org.deegree.console.AbstractCreateResourceBean;
import org.deegree.db.ConnectionProviderManager;

/**
 * JSF backing bean for "Create new database connection" view.
 *
 * @author <a href="mailto:schneider@occamlabs.de">Markus Schneider</a>
 * @since 3.4
 */
@ManagedBean
@ViewScoped
public class CreateSqlConnectionBean extends AbstractCreateResourceBean {

	public CreateSqlConnectionBean() {
		super(ConnectionProviderManager.class);
	}

	@Override
	protected String getOutcome() {
		return "/console/connection/sql/index";
	}

}

deegree-services/deegree-webservices/src/main/java/org/deegree/console/connection/sql/JdbcBean.java
package org.deegree.console.connection.sql;

import static javax.faces.application.FacesMessage.SEVERITY_ERROR;
import static javax.faces.application.FacesMessage.SEVERITY_INFO;
import static org.deegree.db.ConnectionProviderUtils.getSyntheticProvider;

import java.io.IOException;
import java.io.Serializable;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Map;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

import org.deegree.console.Config;
import org.deegree.console.workspace.WorkspaceBean;
import org.deegree.db.ConnectionProvider;
import org.deegree.workspace.ResourceLocation;
import org.deegree.workspace.Workspace;

@ManagedBean
@ViewScoped
public class JdbcBean implements Serializable {

	private static final long serialVersionUID = -425251614342669735L;

	private String dbType = "mssql";

	private String dbPort = "1433";

	private String dbHost;

	private String dbName;

	private String dbConn;

	private String dbUser;

	private String dbPwd;

	private Config config;

	public String getDbType() {
		return dbType;
	}

	public String getDbPort() {
		return dbPort;
	}

	public String getDbHost() {
		return dbHost;
	}

	public String getDbName() {
		return dbName;
	}

	public String getDbConn() {
		return dbConn;
	}

	public String getDbUser() {
		return dbUser;
	}

	public String getDbPwd() {
		return dbPwd;
	}

	public void setDbType(String dbType) {
		this.dbType = dbType;
		if (dbType.equals("mssql")) {
			dbPort = "1433";
			dbConn = "jdbc:sqlserver://" + dbHost + ":" + dbPort + ";databaseName=" + dbName;
			return;
		}
		if (dbType.equals("oracle")) {
			dbPort = "1521";
			dbConn = "jdbc:oracle:thin:@" + dbHost + ":" + dbPort + ":" + dbName;
			return;
		}
		if (dbType.equals("postgis")) {
			dbPort = "5432";
			dbConn = "jdbc:postgresql://" + dbHost + ":" + dbPort + "/" + dbName;
			return;
		}
	}

	public void setDbPort(String dbPort) {
		this.dbPort = dbPort;
		update();
	}

	public void setDbHost(String dbHost) {
		this.dbHost = dbHost;
		update();
	}

	public void setDbName(String dbName) {
		this.dbName = dbName;
		update();
	}

	public void setDbUser(String dbUser) {
		this.dbUser = dbUser;
		update();
	}

	public void setDbPwd(String dbPwd) {
		this.dbPwd = dbPwd;
		update();
	}

	public void setDbConn(String dbConn) {
		this.dbConn = dbConn;
		update();
	}

	public void update() {
		if (dbType.equals("mssql")) {
			if (dbPort == null || dbPort.isEmpty()) {
				dbPort = "1433";
			}
			dbConn = "jdbc:sqlserver://" + dbHost + ":" + dbPort + ";databaseName=" + dbName;
			return;
		}
		if (dbType.equals("oracle")) {
			if (dbPort == null || dbPort.isEmpty()) {
				dbPort = "1521";
			}
			dbConn = "jdbc:oracle:thin:@" + dbHost + ":" + dbPort + ":" + dbName;
			return;
		}
		if (dbType.equals("postgis")) {
			if (dbPort == null || dbPort.isEmpty()) {
				dbPort = "5432";
			}
			dbConn = "jdbc:postgresql://" + dbHost + ":" + dbPort + "/" + dbName;
			return;
		}
	}

	public String editAsXml() throws IOException {
		create();
		if (config != null) {
			return config.edit();
		}
		return null;
	}

	public void testConnection() {

		ExternalContext ctx = FacesContext.getCurrentInstance().getExternalContext();
		Map<String, Object> sMap = ctx.getSessionMap();
		String newId = (String) sMap.get("newConfigId");

		Connection conn = null;
		try {
			conn = DriverManager.getConnection(dbConn, dbUser, dbPwd);
			FacesMessage fm = new FacesMessage(SEVERITY_INFO, "Connection '" + newId + "' ok", null);
			FacesContext.getCurrentInstance().addMessage(null, fm);
		}
		catch (SQLException e) {
			FacesMessage fm = new FacesMessage(SEVERITY_ERROR,
					"Connection '" + newId + "' unavailable: " + e.getMessage(), null);
			FacesContext.getCurrentInstance().addMessage(null, fm);
		}
		finally {
			if (conn != null) {
				try {
					conn.close();
				}
				catch (SQLException e) {
					// nothing to do
				}
			}
		}
	}

	public void cancel() {
		clearFields();
	}

	private void clearFields() {
		dbType = "mssql";
		dbPort = "1433";
		dbHost = null;
		dbName = null;
		dbConn = null;
		dbUser = null;
		dbPwd = null;
	}

	public String save() {
		create();
		clearFields();
		return "/console/connection/sql/index";
	}

	private void create() {
		ExternalContext ctx = FacesContext.getCurrentInstance().getExternalContext();
		Workspace ws = ((WorkspaceBean) ctx.getApplicationMap().get("workspace")).getActiveWorkspace()
			.getNewWorkspace();
		try {
			Map<String, Object> sMap = ctx.getSessionMap();
			String newId = (String) sMap.get("newConfigId");

			ResourceLocation<ConnectionProvider> loc = getSyntheticProvider(newId, dbConn, dbUser, dbPwd);
			ws.add(loc);
			ws.init(loc.getIdentifier(), null);

			ws.getLocationHandler().persist(loc);
		}
		catch (Throwable t) {
			FacesMessage fm = new FacesMessage(SEVERITY_ERROR, "Unable to create config: " + t.getMessage(), null);
			FacesContext.getCurrentInstance().addMessage(null, fm);
		}
	}

}

deegree-services/deegree-webservices/src/main/webapp/console/connection/sql/create.xhtml
<ui:composition template="/layout.xhtml" xmlns="http://www.w3.org/1999/xhtml" xmlns:h="http://xmlns.jcp.org/jsf/html"
  xmlns:f="http://xmlns.jcp.org/jsf/core" xmlns:ui="http://xmlns.jcp.org/jsf/facelets">
  <ui:define name="center">
    <h:panelGroup>
      <fieldset class="fieldset">
        <legend>
          <h:outputText styleClass="titel" value="Create new database connection" />
        </legend>
        <h:form>
          <h:panelGroup>
            <h:outputLabel styleClass="label" for="newFSBt" value="Identifier" />
            <h:inputText styleClass="liste" id="newFSBt" value="#{createSqlConnectionBean.id}" size="16" required="true"
              requiredMessage="#{labels.resource_name_req}" />
            <br />
            <h:panelGroup>
              <h:outputLabel styleClass="label" for="newFSBt" value="Type" />
              <h:selectOneMenu styleClass="liste" value="#{createSqlConnectionBean.type}">
                <f:selectItems value="#{createSqlConnectionBean.types}" />
                <f:ajax listener="#{createSqlConnectionBean.changeType}" render="templates" />
              </h:selectOneMenu>
            </h:panelGroup>
            <h:panelGroup id="templates">
              <h:outputText value="XML config template" />
              <h:selectOneMenu styleClass="liste" value="#{createSqlConnectionBean.configTemplate}">
                <f:selectItems value="#{createSqlConnectionBean.configTemplates}" />
              </h:selectOneMenu>
            </h:panelGroup>
            <br />
            <h:commandButton styleClass="buttonCreateNew" value="#{labels.featureStores_new}"
              action="#{createSqlConnectionBean.create}" />
          </h:panelGroup>
        </h:form>
      </fieldset>
    </h:panelGroup>
  </ui:define>
</ui:composition>

deegree-services/deegree-webservices/src/main/webapp/console/connection/sql/index.xhtml
<ui:composition template="/layout.xhtml" xmlns="http://www.w3.org/1999/xhtml" xmlns:h="http://xmlns.jcp.org/jsf/html"
  xmlns:f="http://xmlns.jcp.org/jsf/core" xmlns:ui="http://xmlns.jcp.org/jsf/facelets">
  <ui:define name="center">
    <f:view>
      <h:panelGroup>
        <fieldset class="fieldset">
          <legend>
            <h:outputText styleClass="titel" value="SQL database connections" />
          </legend>
          <h:form>
            <table style="font-size: small; margin-bottom: 20px">
              <ui:repeat value="#{sqlConnectionManagerBean.configs}" var="config">
                <tr align="left">
                  <td><h:outputLabel styleClass="buttonActivate" rendered="#{config.state=='Initialized'}"
                      value="#{labels.featureStores_deactivate}" /> <h:outputLabel styleClass="buttonDeactivate"
                      rendered="#{config.state!='Error' and config.state!='Initialized'}" value="#{labels.featureStores_activate}" /> <h:outputLabel
                      styleClass="buttonError" rendered="#{config.state=='Error'}" value="!" /></td>
                  <td />
                  <td><h:outputLabel styleClass="buttonDeactivate" value="#{config.id}" /></td>
                  <td><h:commandButton styleClass="buttonInfo" rendered="#{config.state=='Initialized'}"
                      value="Deactivate" action="#{config.deactivate}" /> <h:commandButton styleClass="buttonInfo"
                      rendered="#{config.state!='Error' and config.state!='Initialized'}" value="Activate" action="#{config.activate}" /></td>
                  <td><h:commandButton styleClass="buttonEdit" value="#{labels.featureStores_edit}"
                      action="#{config.edit}" /></td>
                  <td><h:commandButton styleClass="buttonDelete" value="#{labels.featureStores_delete}"
                      action="#{config.delete}" onclick="return confirmDelete();" /></td>
                  <td><h:commandButton styleClass="buttonError" rendered="#{config.state=='Error'}"
                      value="Show errors" action="#{config.showErrors}" /></td>
                </tr>
              </ui:repeat>
            </table>
          </h:form>
          <h:form>
            <h:link styleClass="buttonCreateNew" value="#{labels.featureStores_new}" outcome="create" />
          </h:form>
        </fieldset>
      </h:panelGroup>
    </f:view>
  </ui:define>
</ui:composition>

deegree-services/deegree-webservices/src/main/webapp/console/connection/sql/jdbc.xhtml
<ui:composition template="/layout.xhtml" xmlns="http://www.w3.org/1999/xhtml" xmlns:h="http://xmlns.jcp.org/jsf/html"
  xmlns:f="http://xmlns.jcp.org/jsf/core" xmlns:ui="http://xmlns.jcp.org/jsf/facelets">
  <ui:define name="center">
    <h:panelGroup rendered="#{!logBean.loggedIn}">
      <ui:include src="accessForbidden.xhtml" />
    </h:panelGroup>
    <h:panelGroup rendered="#{logBean.loggedIn}">
      <fieldset class="fieldset">
        <legend>
          <h:outputText styleClass="titel" value="jdbc" />
        </legend>
        <h:form>
          <table style="font-size: small" border="0">
            <tr>
              <td />
            </tr>
            <tr>
              <td />
            </tr>
            <tr>
              <td><h:outputText value="DB type: " /></td>
              <td><h:selectOneMenu value="#{jdbcBean.dbType}">
                  <f:selectItem itemValue="mssql" itemLabel="MSSQL" />
                  <f:selectItem itemValue="oracle" itemLabel="Oracle" />
                  <f:selectItem itemValue="postgis" itemLabel="PostGIS" />
                </h:selectOneMenu></td>
            </tr>
            <tr>
              <td><h:outputText value="Host: " /></td>
              <td><h:inputText id="dbHost" size="15" required="true" value="#{jdbcBean.dbHost}" /></td>
            </tr>
            <tr>
              <td><h:outputText value="Port: " /></td>
              <td><h:inputText id="dbPort" size="5" required="true" value="#{jdbcBean.dbPort}" /></td>
            </tr>
            <tr>
              <td><h:outputText value="DB name: " /></td>
              <td><h:inputText id="dbName" size="20" required="true" value="#{jdbcBean.dbName}" /></td>
            </tr>
            <tr>
              <td><h:outputText value="Preview: " /></td>
              <td><h:inputText value="#{jdbcBean.dbConn}" /></td>
            </tr>
            <tr>
              <td><h:outputText value="Username: " /></td>
              <td><h:inputText value="#{jdbcBean.dbUser}" /></td>
            </tr>
            <tr>
              <td><h:outputText value="Password: " /></td>
              <td><h:inputSecret redisplay="false" value="#{jdbcBean.dbPwd}" /></td>
            </tr>
          </table>
        </h:form>
        <h:form>
          <div>
            <h:commandButton styleClass="buttonInfo" rendered="#{config.state=='init_ok'}" value="#{labels.jdbc_test}"
              action="#{connectionTester.test}" alt="#{config.id}">
              <f:setPropertyActionListener target="#{actionParams.param1}" value="#{config.id}" />
            </h:commandButton>
          </div>
        </h:form>
      </fieldset>
    </h:panelGroup>
  </ui:define>
</ui:composition>

deegree-services/deegree-webservices/src/main/webapp/console/connection/sql/jdbcparams.xhtml
<ui:composition template="/layout.xhtml" xmlns="http://www.w3.org/1999/xhtml" xmlns:h="http://xmlns.jcp.org/jsf/html"
  xmlns:f="http://xmlns.jcp.org/jsf/core" xmlns:ui="http://xmlns.jcp.org/jsf/facelets">
  <ui:define name="center">
    <h:panelGroup>
      <fieldset class="fieldset">
        <legend>
          <h:outputText styleClass="titel" value="jdbc" />
        </legend>
        <h:form>
          <table style="font-size: small" border="0">
            <tr>
              <td />
            </tr>
            <h:commandButton styleClass="buttonEdit" value="Use XML editor" action="#{jdbcBean.editAsXml}"></h:commandButton>
            <tr>
              <td />
            </tr>
            <tr>
              <td><h:outputText value="DB type: " /></td>
              <td><h:selectOneMenu styleClass="liste" value="#{jdbcBean.dbType}">
                  <f:selectItem itemValue="mssql" itemLabel="MSSQL" />
                  <f:selectItem itemValue="oracle" itemLabel="Oracle" />
                  <f:selectItem itemValue="postgis" itemLabel="PostGIS" />
                  <f:ajax render="dbConn dbPort" />
                </h:selectOneMenu></td>
            </tr>
            <tr>
              <td><h:outputText value="Host: " /></td>
              <td><h:inputText id="dbHost" size="25" required="true" requiredMessage="#{labels.jdbc_edit_host_req}"
                  value="#{jdbcBean.dbHost}">
                  <f:ajax render="dbConn" />
                </h:inputText> <h:outputText value=" Port: " /> <h:inputText id="dbPort" size="5" required="true"
                  requiredMessage="#{labels.jdbc_edit_port_req}" value="#{jdbcBean.dbPort}">
                  <f:validateLongRange minimum="0" maximum="65535" />
                  <f:ajax render="dbConn" />
                </h:inputText></td>
            </tr>
            <tr>
              <td><h:outputText value="DB name: " /></td>
              <td><h:inputText id="dbName" size="25" required="true"
                  requiredMessage="#{labels.jdbc_edit_dbname_req}" value="#{jdbcBean.dbName}">
                  <f:ajax render="dbConn" />
                </h:inputText></td>
            </tr>
            <tr>
              <td><h:outputText value="Username: " /></td>
              <td><h:inputText id="dbUser" size="25" required="true" requiredMessage="#{labels.jdbc_edit_user_req}"
                  value="#{jdbcBean.dbUser}">
                  <f:ajax render="dbConn" />
                </h:inputText></td>
            </tr>
            <tr>
              <td><h:outputText value="Password: " /></td>
              <td><h:inputText id="dbPwd" size="10" value="#{jdbcBean.dbPwd}">
                  <f:ajax render="dbConn" />
                </h:inputText></td>
            </tr>
            <tr>
              <td><h:outputText value="jdbc URL: " /></td>
              <td><h:inputText id="dbConn" size="50" required="true" requiredMessage="#{labels.jdbc_edit_conn_req}"
                  redisplay="false" value="#{jdbcBean.dbConn}" /></td>
            </tr>
            <tr>
              <td><br /> <h:commandButton styleClass="buttonInfo" value="#{labels.jdbc_test}"
                  action="#{jdbcBean.testConnection}" alt="#{config.id}">
                </h:commandButton></td>
            </tr>
          </table>
          <br />
          <div>
            <h:commandButton styleClass="buttonCreateNew" value="Create" action="#{jdbcBean.save}">
              <f:setPropertyActionListener target="#{actionParams.param1}" value="#{config.id}" />
            </h:commandButton>
            <h:outputLink styleClass="buttonCancel" value="../../#{configManager.currentResourceManager.startView}.jsf"
              action="#{jdbcBean.cancel}">
              <h:outputText value="Cancel" />
            </h:outputLink>
          </div>
        </h:form>
      </fieldset>
    </h:panelGroup>
  </ui:define>
</ui:composition>